<template>
  <div class="page-box" style="position: relative;">
    <el-form
      ref="formTourVisaTypeRef"
      :size="layoutStore.defaultFormItemSize"
      label-width="120px"
      label-position="right"
      @submit.prevent
    >
      <filter-box :item-width="350" @search="refreshFormTourVisaType()" @reset="resetFormTourVisaType">
        <el-form-item label="签证类型名称">
          <el-input
            class="filter-item"
            v-model="formFilter.titleFilter"
            type="text"
            placeholder=""
            :clearable="true"
            :show-word-limit="false"
            maxlength=""
          />
        </el-form-item>
      </filter-box>
    </el-form>
    <table-box
      ref="formTourVisaTypeTable"
      class="page-table"
      :data="formTourVisaTypeTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formTourVisaTypeTableWidgetCurrentPage - 1) * formTourVisaTypeTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formTourVisaTypeTableWidget.onSortChange"
      @refresh="formTourVisaTypeTableWidget.refreshTable()"
    >
      <template #operator>
<!--        <el-button-->
<!--          type="primary"-->
<!--          :size="layoutStore.defaultFormItemSize"-->
<!--          @click="onAddTourVisaTypeClick()"-->
<!--          >-->
<!--          新建-->
<!--        </el-button>-->
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportTourVisaTypeClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :on-change="onImportTourVisaTypeClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formTourVisaTypeTableWidget.getTableIndex" :width="80" />
      <vxe-column title="签证类型名称" field="title" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditTourVisaTypeClick(scope.row)"
          >
            编辑
          </el-button>
<!--          <el-button-->
<!--            link-->
<!--            type="primary"-->
<!--            :size="layoutStore.defaultFormItemSize"-->
<!--            @click.stop="onDeleteTourVisaTypeClick(scope.row)"-->
<!--          >-->
<!--            删除-->
<!--          </el-button>-->
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formTourVisaTypeTableWidgetTotalCount"
            :current-page="formTourVisaTypeTableWidgetCurrentPage"
            :page-size="formTourVisaTypeTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formTourVisaTypeTableWidget.onCurrentPageChange"
            @size-change="formTourVisaTypeTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formTourVisaType',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { TourVisaTypeData } from '@/api/generated/tourVisaTypeController';
import { TourVisaTypeController } from '@/api/generated';
import FormEditTourVisaType from '@/pages/tourVisaType/formEditTourVisaType.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const {
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);

const formFilter = reactive({
  // 签证类型名称
  titleFilter: undefined,
});
const formFilterCopy = reactive({
  // 签证类型名称
  titleFilter: undefined,
});

const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormTourVisaType();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormTourVisaTypeTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
    tourVisaTypeDtoFilter: {
      title: formFilter.titleFilter,
    }
  };
  return new Promise((resolve, reject) => {
    TourVisaTypeController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormTourVisaTypeTableVerify = () => {
  formFilterCopy.titleFilter = formFilter.titleFilter;
  return true;
};
/**
 * 新建
 */
const onAddTourVisaTypeClick = (row?: TourVisaTypeData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditTourVisaType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourVisaTypeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditTourVisaTypeClick = (row?: TourVisaTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditTourVisaType, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formTourVisaTypeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportTourVisaTypeClick = (row?: TourVisaTypeData) => {
  let params: ANY_OBJECT = {
  };

  TourVisaTypeController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportTourVisaTypeClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  TourVisaTypeController.import(params).then(res => {
    ElMessage.success('导入成功');
    formTourVisaTypeTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteTourVisaTypeClick = (row?: TourVisaTypeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    TourVisaTypeController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formTourVisaTypeTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formTourVisaTypeTableOptions: TableOptions<TourVisaTypeData> = {
  loadTableData: loadFormTourVisaTypeTableWidgetData,
  verifyTableParameter: loadFormTourVisaTypeTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formTourVisaTypeTable = ref();
const formTourVisaTypeTableWidget = useTable(formTourVisaTypeTableOptions);
const {
  dataList: formTourVisaTypeTableWidgetDataList,
  currentPage: formTourVisaTypeTableWidgetCurrentPage,
  pageSize: formTourVisaTypeTableWidgetPageSize,
  totalCount: formTourVisaTypeTableWidgetTotalCount,
} = formTourVisaTypeTableWidget;
const refreshFormTourVisaType = () => {
  // 刷新段落
  formTourVisaTypeTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormTourVisaType = () => {
  formFilter.titleFilter = undefined;
  formFilterCopy.titleFilter = undefined;
  refreshFormTourVisaType();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormTourVisaType();
};
const formInit = () => {
  refreshFormTourVisaType();
};

onMounted(() => {
  formInit();
});
</script>
